Redmine - Patch #37591

Use start_with? or end_with? to check the first or last character of a string

2022-08-22 11:25 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: 5.1.0

Description

String#start_with? and String#end_with? are more intuitive and faster than [0, 1] or [-1, 1].

require 'benchmark/ips'
Benchmark.ips do |bench]
path = '/foo'
bench.report ('[0, 1]') do
path[0, 1] == '/'
end
bench.report ('start_with?') do
path.start_with? ('/")

end

bench.compare!
end

Warming up —————————————————————————————————————

[0, 1] 514.843k 1/100ms
start_with? 830.117k 1/100ms

Calenlatiling —————————————————eeee e
[0, 1] 5.201IM (£ 3.1%) i/s -
start_with? 8.254M (+ 3.2%) i/s -
Comparison:
start_with?: 8253500.9 i/s
[0, 1]: 5201251.4 i/s - 1.59x (*

26.257M in 5.053268s
41.506M in 5.034294s

0.00) slower

Associated revisions

Revision 21774 - 2022-08-24 15:45 - Go MAEDA

Use start_with? or end_with? to check the first or last character of a string (#37591).

Patch by Go MAEDA.

History

#1 - 2022-08-24 10:38 - Go MAEDA

- Target version set to 5.1.0

Setting the target version to 5.1.0.

#2 - 2022-08-24 15:45 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch.
